// $Id$

//////////////////////////////////////////////////////////////////////////

#include "util.h"

//////////////////////////////////////////////////////////////////////////

#include <cassert>
#include <cmath>
#include <string>
#include <iterator>

//////////////////////////////////////////////////////////////////////////

bool is_ipl_depth_valid(int const depth)
{
  switch(depth)
  {
  case IPL_DEPTH_8U:
  case IPL_DEPTH_8S:
  case IPL_DEPTH_16U:
  case IPL_DEPTH_16S:
  //case IPL_DEPTH_32U:
  case IPL_DEPTH_32S:
  case IPL_DEPTH_32F:
  case IPL_DEPTH_64F:
    return true;
  default:
    ;
  }
  return false;
}

//////////////////////////////////////////////////////////////////////////

char const * ipl_depth_name(int const depth)
{
  switch(depth)
  {
  case IPL_DEPTH_8U:  return "8 bits unsigned fixed";
  case IPL_DEPTH_8S:  return "8 bits signed fixed";
  case IPL_DEPTH_16U: return "16 bits unsigned fixed";
  case IPL_DEPTH_16S: return "16 bits signed fixed";
  //case IPL_DEPTH_32U: return "32 bits unsigned fixed"; // not supported
  case IPL_DEPTH_32S: return "32 bits signed fixed";
  case IPL_DEPTH_32F: return "32 bits floating point";
  case IPL_DEPTH_64F: return "64 bits floating point";
  default:
    ;
  }
  return "undefined";
}

//////////////////////////////////////////////////////////////////////////

// End of File
