// $Id: test.cpp,v 1.2 2008/07/08 07:10:28 fazekas Exp $

//////////////////////////////////////////////////////////////////////////

#include "imgptr.h"

#include <cv.h>

#include <cstdlib>
#include <iostream>
#include <vector>

//////////////////////////////////////////////////////////////////////////

int main(int argc, char * argv[])
{
  int const w = 4, h = 3;

  short int a[w*h] =
  {
    1, 2, 3, 4,
    5, 6, 7, 8,
    9, 10, 11, 12,
  };

  CvMat Ma;
  cvInitMatHeader(&Ma, h, w, CV_16UC1, a);

  cv::img_ptr im (Ma); // clones data
  assert(im != 0 && im->width == w && im->height == h);

  cv::img_ptr im2 (im); // clones data
  cvAdd(im, im2, &Ma); // can be passed to opencv
  std::cout << std::endl;

  for(int y = 0; y < h; ++y)
  {
    for(int x = 0; x < w; ++x)
    {
      int const xy = y * w + x;
      std::cout << a[xy] << ' ';
    }
    std::cout << std::endl;
  }

  std::cout << std::endl;
  std::vector<cv::img_ptr> im_vec (5);
  for(int k = 0; k < im_vec.size(); ++k)
  {
    im_vec[k] = Ma;
  }

  std::cout << std::endl;
  std::vector<cv::img_ptr> const im_vec2 (im_vec);
  for(int k = 0; k < im_vec.size(); ++k)
  {
    std::cout
      << im_vec2[k]->width << " " << im_vec2[k]->height
      << std::endl;
  }

  return EXIT_SUCCESS;
}

//////////////////////////////////////////////////////////////////////////

// End of File
