#ifndef UTIL_H
#define UTIL_H

// $Id$

//////////////////////////////////////////////////////////////////////////

#include <cv.h>

//////////////////////////////////////////////////////////////////////////

inline
bool operator==(const CvSize& a, const CvSize& b)
{
  return (a.width == b.width) && (a.height == b.height);
}

inline
bool operator!=(const CvSize& a, const CvSize& b)
{
  return !(a == b);
}

//////////////////////////////////////////////////////////////////////////

bool is_ipl_depth_valid(int const depth); // runtime check
char const * ipl_depth_name(int const depth); // short description

//////////////////////////////////////////////////////////////////////////

void cart_to_spheric(const CvArr * src, CvArr * dst);
void spheric_to_cart(const CvArr * src, CvArr * dst);

//////////////////////////////////////////////////////////////////////////

#endif // UTIL_H
