#ifndef INPAINT_DT_H
#define INPAINT_DT_H

// $Id$

//////////////////////////////////////////////////////////////////////////

#include <cv.h>

//////////////////////////////////////////////////////////////////////////

// Simple inpainting based on distance transform

class inpaint_dt_func
{
protected:
  void * _intern; // opaque INTERNAL DATA

public:
  inpaint_dt_func(); // NO MEMORY ALLOCATED
  virtual ~inpaint_dt_func();

public:
  inpaint_dt_func(inpaint_dt_func const & func);
  inpaint_dt_func & operator=(inpaint_dt_func const & func);

public:
  void reset(); // DEALLCATES MEMORY (drops internal data)

public:
  // ALLOCATES and REALLOCATES MEMORY as needed

  // works with multichannel images (input, output)
  // the 'mask' must be single channeled

  void operator()(CvArr const * in, CvArr const * mask, CvArr * out);
};

//////////////////////////////////////////////////////////////////////////

#endif // INPAINT_DT_H
