% Investigates all lines to detect wires or scratches
%

progressbar(0,4);

%% variables
contrast = 10;
distance = 5;

%% 

figure(2); imshow(I);
scratchno = 0;
lineseg = round(lineseg);

Iheight = size(I,1); 
Iwidth = size(I,2); 
clear heightset; clear widthset;
heightset = d+5:(Iheight-d-5);
widthset = d+5:(Iwidth-d-5);

numbers_of_lines = size(lineseg,1);

finalmask = zeros(size(I,1),size(I,2));

%% looping through all lines
for i = 1:numbers_of_lines
    angles(i) = atan((lineseg(i,1)-lineseg(i,2))...
                      /(lineseg(i,3)-lineseg(i,4))); %#ok
                  
    if (ismember(lineseg(i,1),widthset) && ...
            ismember(lineseg(i,2),widthset)&& ...
            ismember(lineseg(i,3),heightset)&& ...
            ismember(lineseg(i,4),heightset) && ...
            abs(angles(i))>=pi/8 && abs(angles(i))<=6*pi/8)
         
        % calculating angles and translation vectors
        angle = angles(i) + pi/2;
        addx = distance*sin(angle);
        addy = distance*cos(angle);    
        addx2 = distance*sin(angle);
        addy2 = distance*cos(angle);

        % creating lines
        line1 = [lineseg(i,1)+addx, ...
                 lineseg(i,2)+addx, ...
                 lineseg(i,3)+addy, ...
                 lineseg(i,4)+addy];

        line2 = [lineseg(i,1)-addx, ...
                 lineseg(i,2)-addx, ...
                 lineseg(i,3)-addy, ...
                 lineseg(i,4)-addy];   
        
        line1 = round(line1);
        line2 = round(line2);
        
        mask = zeros(size(I,1),size(I,2));
        % creating masks for each side of the line
        mask1 = func_Drawline(mask, line1(3), line1(1), line1(4), line1(2), 1);
        mask2 = func_Drawline(mask, line2(3), line2(1), line2(4), line2(2), 1);
        maskline = func_Drawline(mask, lineseg(i,3), lineseg(i,1), lineseg(i,4), lineseg(i,2), 1);

        % making the lines thicker
        SE = strel('disk', 1, 4);
        mask1d = imdilate(mask1, SE);    
        mask2d = imdilate(mask2, SE);
        masklined = imdilate(maskline, SE);

        m1 = uint8(I).*uint8(mask1d);
        m2 = uint8(I).*uint8(mask2d);
        mline = uint8(I).*uint8(masklined);
        
        % calculating mean values of the lines 
        area1 = m1(m1~=0);
        areamean1 = mean(area1);
        area2 = m2(m2~=0);
        areamean2 = mean(area2);
        arealine = mline(mline~=0);
        areameanline = mean(arealine);
        
%% Drawing lines onto the image (for visual inspection only)
        
        % abs(areamean1-areamean2)<= 30 && ...
        if abs(areamean1-areamean2)<= contrast && ...
                areameanline <= (areamean1+areamean2)/2+30 
            
           scratchno = scratchno+1; 
           finalmask(masklined==1) = 1;
           
           DrawLines_2Ends(lineseg(i,:),'r');
%            DrawLines_2Ends(line1,'w');
%            DrawLines_2Ends(line2,'w');
        else
            DrawLines_2Ends(lineseg(i,:),'black');
        end

%         lines(i) = [line1 line2];  %#ok
    end
    progressbar(i/numbers_of_lines,4);
end


% post processing of the mask
SE = strel('disk', 1, 6);
final = imdilate(finalmask, SE);    

 figure; imagesc(final); colormap(gray);       
% lines = [];

 fi = medfilt2(final,[7 7]);
 fi = imdilate(fi, SE);
